#version 430 core

#include "global.inc"

out VertexOutput 
{
	vec2 uv;
} vertexOutput;

void main() 
{
	// based on:
	// https://gamedev.stackexchange.com/questions/155183/how-does-the-following-code-generate-a-full-screen-quad
	// flipped: uvs starting bottom left, counterclockwise triangle

	int id = gl_VertexID;
	vertexOutput.uv = vec2(id & 2, ((id & 1) ^ 1) * 2 - 1);
	gl_Position = vec4(vertexOutput.uv * vec2(2, 2) + vec2(-1, -1), 0, 1);

	// Short for:
	/*
	if (id == 0)
	{
		vertexOutput.uv = vec2(0, 1);
		gl_Position = vec4(-1, 1, 0, 1);	
	} else if (id == 1)
	{
		vertexOutput.uv = vec2(0, -1);
		gl_Position = vec4(-1, -3, 0, 1);	
	} else if (id == 2)
	{
		vertexOutput.uv = vec2(2, 1);
		gl_Position = vec4(3, 1, 0, 1);	
	}
	*/
}