#version 430 core

in VertexOutput
{
	vec2 uv;
} vertexOutput;

#ifdef SKYBOX_IN
    uniform sampler2D skyboxResult;
#endif

#ifdef DIRECT_IN
    uniform sampler2D directResult;
#endif

#ifdef ENVIRONMENT_IN
    uniform sampler2D environmentResult;
#endif

#ifdef VOLUMETRIC_IN
    uniform sampler2D volumetricResult;
#endif

#ifdef SSDO_IN
    uniform sampler2D ssdoResult;
#endif

#ifdef INDIRECT_IN
    uniform sampler2D indirectResult;
#endif

out vec4 fragColor;

void main() {
    vec2 uv = vertexOutput.uv;
    vec3 combinedLighting = vec3(0);

    #ifdef DIRECT_IN
        combinedLighting += texture(directResult, uv).rgb;
    #endif

    #ifdef ENVIRONMENT_IN
        combinedLighting += texture(environmentResult, uv).rgb;
    #endif

    #ifdef VOLUMETRIC_IN
        combinedLighting += texture(volumetricResult, uv).rgb;
    #endif

    #ifdef SSDO_IN
        combinedLighting += texture(ssdoResult, uv).rgb;
    #endif

    #ifdef INDIRECT_IN
        combinedLighting += texture(indirectResult, uv).rgb;
    #endif

    //combinedLighting *= INV_NUM_INPUTS;

    #ifdef SKYBOX_IN
        // TODO: find out why the fuck the following does not work:
        //combinedLighting += texture(skyboxResult, uv).rgb;
        combinedLighting = max(texture(skyboxResult, uv).rgb, combinedLighting);
    #endif

    fragColor = vec4(combinedLighting, 1);
}

