#version 430 core

#include "global.inc"

in VertexOutput 
{
	float alpha;
	vec2 uv;
	vec4 clip;
	flat int color;

	#ifdef ANIMATED
		flat int texNr;
	#endif
} vertexOutput;

uniform sampler2D particleTex;
uniform vec3 particleColors[5];

out vec4 fragColor;

void main() 
{
	float fragDepth = gl_FragCoord.z;
	float fragZ = restoreZ(fragDepth);
	
	vec2 screenUv = (vertexOutput.clip.xy / vertexOutput.clip.z + 1.0f) * 0.5f;
	float sceneDepth = texture(depthTex, screenUv).r;
	float sceneZ = restoreZ(sceneDepth);

	float distance = abs(sceneZ - fragZ);
	//float alpha = mapRange(0, 0.2, 0, vertexOutput.alpha, distance);
	float alpha=1;
	if(distance<0.1){
		alpha = 0;
	}

	vec4 texColor;
	#ifdef ANIMATED
		texColor = texture(particleTex, vec2((vertexOutput.texNr%10)/10.0,(0.8-(vertexOutput.texNr-(vertexOutput.texNr%10))/50.0))+ vertexOutput.uv/vec2(10.0,5.0));
	#endif

	#ifdef NOT_ANIMATED
		texColor = texture(particleTex, vertexOutput.uv);
	#endif

	vec3 finalColor = texColor.rgb * particleColors[vertexOutput.color];
	// undefined variable 'brightness'
	//finalColor *= brightness;
	fragColor = vec4(finalColor, texColor.a * vertexOutput.alpha);

	//debug
	//fragColor = vec4(particleColors[int(vertexOutput.color)],1);
	//fragColor = vec4(texColor.rgb * particleColors[1], texColor.a * vertexOutput.alpha);
	//fragColor = vec4(particleColors[1],1);
	//float r =texture(depthTex,vertexOutput.uv).r;
	//fragColor = vec4(distance,distance,distance,1);
	//fragColor = texture(particleTex, vertexOutput.uv);
}

