#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 uv0;

uniform sampler2D downsampled;

out VertexOutput
{
	vec2 uv;
	vec2 surrounding[4];
} vertexOutput;

void main() {
    vec2 texelSize = 1.0 / textureSize(downsampled, 0);
    vec2 sizeX = vec2(texelSize.x, 0.0);
    vec2 sizeY = vec2(0.0, texelSize.y);

	vertexOutput.uv = uv0;
	vertexOutput.surrounding[0] = uv0 - texelSize;
	vertexOutput.surrounding[1] = uv0 - sizeX;
	vertexOutput.surrounding[2] = uv0 - sizeY;
	vertexOutput.surrounding[3] = uv0;

	gl_Position = vec4(position.x, position.y, 0, 1);
}