#version 430

#include "global.inc"

in VertexOutput
{
	vec2 uv;
	vec2 surrounding[4];
} vertexOutput;

uniform sampler2D gPosition;

out vec4 fragColor;

int minDimension(vec4 v) {
    int dim = 0;
    float minComponent = v.x;
    for (int i = 1; i < 4; ++i) {
        if (v[i] < minComponent) {
            dim = i;
            minComponent = v[i];
        }
    }
    return dim;
}

int maxDimension(vec4 v) {
    int dim = 0;
    float maxComponent = v.x;
    for (int i = 1; i < 4; ++i) {
        if (v[i] > maxComponent) {
            dim = i;
            maxComponent = v[i];
        }
    }
    return dim;
}

void main() {
	vec4 depth = vec4(
		(camera.view * texture(gPosition, vertexOutput.surrounding[0])).z,
		(camera.view * texture(gPosition, vertexOutput.surrounding[0])).z,
		(camera.view * texture(gPosition, vertexOutput.surrounding[0])).z,
		(camera.view * texture(gPosition, vertexOutput.surrounding[0])).z
	);

	vec2 columnRow = mod(vertexOutput.uv, 2);
	int dim = mod(columnRow.x + columnRow.y, 2) == 0 ? minDimension(depth) : maxDimension(depth);

    vec2 uv = vertexOutput.surrounding[dim];
    fragColor = texture(gPosition, uv);
}
