#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec2 uv0;

uniform sampler2D gPosition;

out VertexOutput
{
	vec2 uv;
	vec2 surrounding[4];
} vertexOutput;

void main() {
    vec2 texelSize = 1.0 / textureSize(gPosition, 0);
    vec2 sizeX = vec2(texelSize.x, 0);
    vec2 sizeY = vec2(0, texelSize.y);

	vertexOutput.uv = uv0;
	vec2 tl = uv0 - texelSize * 0.5;
	vec2 tr = tl + sizeX;
	vec2 bl = tl + sizeY;
	vec2 br = bl + sizeX;

    vertexOutput.surrounding[0] = tl;
    vertexOutput.surrounding[1] = tr;
    vertexOutput.surrounding[2] = bl;
    vertexOutput.surrounding[3] = br;

	gl_Position = vec4(position.x, position.y, 0, 1);
}